//+------------------------------------------------------------------+
//|                                              i-Sessions_Line.mq4 |
//|                                             . aka KimIV |
//|                                              http://www.kimiv.ru |
//|  16.11.2005                               |
//+------------------------------------------------------------------+
#property copyright "  . aka KimIV"
#property link      "http://www.kimiv.ru"

#property indicator_chart_window

//-------    -------------------------------
extern int    _ = 10;        // _ 
extern int _ = 3;              // _
extern string AsiaBegin    = "00:00";      //     01:00
extern string AsiaEnd      = "11:00";      //     10:00
extern color  AsiaColor    = MidnightBlue;//        
extern string EurBegin     = "08:00";   //      07:00
extern string EurEnd       = "17:00";   //      16:00
extern color  EurColor     = Maroon;         //   
extern string USABegin     = "15:00";   //     14:00
extern string USAEnd       = "23:59";   //     23:00
extern color  USAColor     = DarkSlateGray; //   

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void init() 
{//+------------------------------------------------------------------+
 DeleteObjects();
 for(int i=0; i<_; i++)//NumberOfDays
    {CreateObjects("AS"+i, AsiaColor);
     CreateObjects("EU"+i, EurColor);
     CreateObjects("US"+i, USAColor);
    }
 Comment("");
return;
}//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
void deinit() 
{//+------------------------------------------------------------------+
 ObjectsDeleteAll(0,OBJ_TREND);//DeleteObjects();//
 Comment("");
return;
}//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                        |
//| :                                                       |
//|   no -                                        |
//|   cl -                                                |
//+------------------------------------------------------------------+

void CreateObjects(string no, color cl)
{//+------------------------------------------------------------------+
 if(ObjectFind(no+"a")==-1)
    ObjectCreate(no+"a", OBJ_TREND, 0, 0,0, 0,0);//OBJ_TREND      OBJ_RECTANGLE
    ObjectSet(no+"a", OBJPROP_STYLE, STYLE_SOLID);
    ObjectSet(no+"a", OBJPROP_COLOR, cl);
    ObjectSet(no+"a", OBJPROP_BACK, True);
    ObjectSet(no+"a", OBJPROP_RAY, 0);
    ObjectSet(no+"a", OBJPROP_WIDTH, _);
    
 if(ObjectFind(no+"b")==-1)  
    ObjectCreate(no+"b", OBJ_TREND, 0, 0,0, 0,0);//OBJ_TREND      OBJ_RECTANGLE
    ObjectSet(no+"b", OBJPROP_STYLE, STYLE_SOLID);
    ObjectSet(no+"b", OBJPROP_COLOR, cl);
    ObjectSet(no+"b", OBJPROP_BACK, True);
    ObjectSet(no+"b", OBJPROP_RAY, 0);
    ObjectSet(no+"b", OBJPROP_WIDTH, _);
    
 if(ObjectFind(no+"c")==-1)   
    ObjectCreate(no+"c", OBJ_TREND, 0, 0,0, 0,0);//OBJ_TREND      OBJ_RECTANGLE
    ObjectSet(no+"c", OBJPROP_STYLE, STYLE_SOLID);
    ObjectSet(no+"c", OBJPROP_COLOR, cl);
    ObjectSet(no+"c", OBJPROP_BACK, True);
    ObjectSet(no+"c", OBJPROP_RAY, 0);
    ObjectSet(no+"c", OBJPROP_WIDTH, _);
 if(ObjectFind(no+"d")==-1)  
    ObjectCreate(no+"d", OBJ_TREND, 0, 0,0, 0,0);//OBJ_TREND      OBJ_RECTANGLE
    ObjectSet(no+"d", OBJPROP_STYLE, STYLE_SOLID);
    ObjectSet(no+"d", OBJPROP_COLOR, cl);
    ObjectSet(no+"d", OBJPROP_BACK, True);
    ObjectSet(no+"d", OBJPROP_RAY, 0);
    ObjectSet(no+"d", OBJPROP_WIDTH, _);
return;    
}//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                        |
//+------------------------------------------------------------------+
void DeleteObjects() 
{//+------------------------------------------------------------------+
 for(int i=0; i<_; i++)//NumberOfDays 
    {
     ObjectDelete("AS"+i);
     ObjectDelete("EU"+i);
     ObjectDelete("US"+i);
    }
return;    
}//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
//..................................................................................................... 
void start()//start   start   start   start   start   start   start   start     
{//............................................................................
  datetime dt=CurTime();

  for(int i=0; i<_; i++)//NumberOfDays
     {DrawObjects(dt, "AS"+i, AsiaBegin, AsiaEnd);
      DrawObjects(dt, "EU"+i, EurBegin, EurEnd);
      DrawObjects(dt, "US"+i, USABegin, USAEnd);
      dt=decDateTradeDay(dt);
      while(TimeDayOfWeek(dt)>5){dt=decDateTradeDay(dt);}
     }   
return(0);  
}//............................................................................
//start   start   start   start   start   start   start   start   start   start
//..................................................................................................... 
//+------------------------------------------------------------------+
//|                                       |
//| :                                                       |
//|   dt -                                           |
//|   no -                                        |
//|   tb -                                          |
//|   te -                                       |
//+------------------------------------------------------------------+
void DrawObjects(datetime dt, string no, string tb, string te)
{//+------------------------------------------------------------------+
    datetime t1, t2;
    double   p1, p2;
    int      b1, b2;

    t1=StrToTime(TimeToStr(dt, TIME_DATE)+" "+tb);
    t2=StrToTime(TimeToStr(dt, TIME_DATE)+" "+te);
    b1=iBarShift(NULL, 0, t1);
    b2=iBarShift(NULL, 0, t2);
    p1=High[Highest(NULL, 0, MODE_HIGH, b1-b2, b2)];
    p2=Low [Lowest (NULL, 0, MODE_LOW , b1-b2, b2)];
    
    ObjectSet(no+"a", OBJPROP_TIME1 , t1);//. .
    ObjectSet(no+"a", OBJPROP_PRICE1, p2);
    ObjectSet(no+"a", OBJPROP_TIME2 , t2);
    ObjectSet(no+"a", OBJPROP_PRICE2, p2);
    
    ObjectSet(no+"b", OBJPROP_TIME1 , t1);//. .
    ObjectSet(no+"b", OBJPROP_PRICE1, p1);
    ObjectSet(no+"b", OBJPROP_TIME2 , t2);
    ObjectSet(no+"b", OBJPROP_PRICE2, p1);
    
    ObjectSet(no+"c", OBJPROP_TIME1 , t1);//. .
    ObjectSet(no+"c", OBJPROP_PRICE1, p1);
    ObjectSet(no+"c", OBJPROP_TIME2 , t1);
    ObjectSet(no+"c", OBJPROP_PRICE2, p2);
    
    ObjectSet(no+"d", OBJPROP_TIME1 , t2);//. .
    ObjectSet(no+"d", OBJPROP_PRICE1, p1);
    ObjectSet(no+"d", OBJPROP_TIME2 , t2);
    ObjectSet(no+"d", OBJPROP_PRICE2, p2);
return;
}//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                  |
//| :                                                       |
//|   dt -                                           |
//+------------------------------------------------------------------+
datetime decDateTradeDay(datetime dt)
{//+------------------------------------------------------------------+
 int ty=TimeYear(dt);
 int tm=TimeMonth(dt);
 int td=TimeDay(dt);
 int th=TimeHour(dt);
 int ti=TimeMinute(dt);

 td--;
 if(td==0)
   {tm--;
    if(tm==0){ty--;tm=12;}
    if(tm==1 || tm==3 || tm==5 || tm==7 || tm==8 || tm==10 || tm==12){td=31;}
    if(tm==2)
      {if(MathMod(ty, 4)==0){td=29;}}
    else{td=28;}
    if(tm==4 || tm==6 || tm==9 || tm==11){td=30;}
   }
return(StrToTime(ty+"."+tm+"."+td+" "+th+":"+ti));
}//+------------------------------------------------------------------+


